# FdoIoStream Class Reference

`#include <Stream.h>`

Inheritance diagram for FdoIoStream:

[legend]

List of all members.

## Detailed Description

FdoIoStream defines the interface for all FDO streams. Streamed I/O support for various locations, such as files, memory, etc. can be provided by classes that implement this interface.

Note:
  There is no function provided to close a FdoIoStream. The only way to close it is to destroy it by releasing all references.

Definition at line 31 of file Stream.h.

## Public Member Functions
virtual FDO_API_COMMON FdoBoolean | CanRead ()
| gets the reading capability.
virtual FDO_API_COMMON FdoBoolean | CanWrite ()
| gets the writing capability.
virtual FDO_API_COMMON FdoInt64 | GetIndex ()=0
| gets the current position for the stream.
virtual FDO_API_COMMON FdoInt64 | GetLength ()=0
| gets the current length of the stream.
virtual FDO_API_COMMON FdoBoolean | HasContext ()
| returns whether the stream has any positional context. Streams without context can only be read and written in a forward-only manner. These streams do not allow position and length changes.
virtual FDO_API_COMMON FdoSize | Read (FdoByte *buffer, FdoSize count)=0
| reads the number of bytes indicated by count into the given buffer, or the number of bytes after the current stream position, whichever is less. The stream’s current position is moved ahead by the number of bytes read.
virtual FDO_API_COMMON void | Reset ()=0
| sets the position to the start of the stream.
virtual FDO_API_COMMON void | SetLength (FdoInt64 length)=0
| truncates the stream to the indicated length.
virtual FDO_API_COMMON void | Skip (FdoInt64 offset)=0
| skips over part of the stream.
virtual FDO_API_COMMON void | Write (FdoIoStream *stream, FdoSize count=0)=0
| reads the number of bytes from the given stream, and writes them to this stream.
virtual FDO_API_COMMON void | Write (FdoByte *buffer, FdoSize count)=0
| writes the number of bytes indicated by count, from the given buffer, to the stream. The current position is moved ahead by the number of bytes written.

The documentation for this class was generated from the following file:

- Stream.h